<?php
/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of XcruderHtml
 *
 * @author nlac
 */
class XcruderHtml extends CHtml {

  public static function dump() {
		return '<pre>GET:' . print_r(@$_GET, true) . '<br/>POST:' . print_r(@$_POST, true) . '</pre>';
  }

/**
 * Related tabview code for $rec
 */
	public static function xpAjaxRenderRelateds($rec) {
		return CHtml::ajax(array(
			'url' => Yii::app()->controller->createUrl('browse/relateds', array(
								'modelPk' => json_encode( $rec->getPrimaryKey() ),
								'modelClass'=> get_class($rec),
								//'modelLevel'=> 1+$_GET['modelLevel']
							)
					),
			//'update' => '#relatedscontainer_' . $_GET['modelLevel']
			'success' => 'js:(function(resp){xcruder.onrender_relateds("#relatedscontainer_' . $_GET['modelLevel'] . '_' . @$_GET['modelRelationName'] . '", resp);})'
		));
	}

/**
 * Update form code for $rec
 **/
	public static function xpAjaxRenderUpdate($rec) {
		return CHtml::ajax(array(
			'url' => Yii::app()->controller->createUrl('update/index', array(
								'updatePk'=> json_encode( $rec->getPrimaryKey() ),
								'updateModelClass'=> get_class($rec),
								'update_grid_id' => Yii::app()->controller->getViewId() . '_grid'
							)
					),
			'success' => 'js:(function(resp){xcruder.onrender_form("#updatecontainer", resp)})'
		));
	}

/**
 * Delete action for $rec
 **/
	public static function xpAjaxRenderDelete($rec) {
		//this request will display the delete view in a popup dialog
		return CHtml::ajax(array(
			'url' => Yii::app()->controller->createUrl('delete/index', array(
								'modelPk' => json_encode( $rec->getPrimaryKey() ),
								'modelClass'=> get_class($rec)
							)
					),
			//'success' => 'js:(function(resp){xcruder.onrender_form("#deletecontainer", resp)})'
		));
	}



	public static function xpBeginForm($controller, $action, $id_form, $class_form="", 
	$updateableGridId="", $beforeSend="undefined", $onSuccess="undefined", $onError="undefined") {
		
		if (!@$beforeSend || @$beforeSend=="undefined")
			$beforeSend = 'function(){xcruder.onbeforesend_form("#' . $id_form . '")}';

		if (!@$onSuccess || @$onSuccess == "undefined")
			$onSuccess = 'function(resp){xcruder.onsuccess_form("#' . $id_form . '", "' . $updateableGridId . '", resp)}';

		if (!@$onError || @$onError == "undefined")
			$onError = $onSuccess;
		
		$opt = array(
				'id' => $id_form,
				//'enableAjaxValidation' => true,
				'enableClientValidation' => true,
				'htmlOptions' => array(
					//triggering onsubmit validation, if the result is true then ajax submitting
					'onsubmit' => "if (xcruder.validateAjaxForm($(this))) $(this).ajaxSubmit({beforeSend:$beforeSend,success:$onSuccess,error:$onError}); return false;",
					'class' => 'xcruder-form ' . $class_form
				),
				'clientOptions' => array(
					//'validateOnChange' => true,
					'validateOnSubmit' => true
				)
		);
		
		//passing through GET params
		if (@$action)
			$opt['action'] = $controller->createUrl($action, @$_GET);
		
		return $controller->beginWidget('XcruderActiveForm', $opt);
	}
	
	public static function xpFormMessage($mess, $htmlClass = '') {
		if (!@$mess)
			return '';
		return '<div class="form-message ' . ($htmlClass ? $htmlClass : '') . '">' . $mess . '</div>';
	}

	public static function xpFormSuccess($success) {
		return self::xpFormMessage($success, 'success');
	}

	public static function xpFormError($error) {
		return self::xpFormMessage($error, 'error');
	}
	
	
	
	
	
	public static function xpSubmitButton($form) {
		return XcruderHtml::button( Yii::t('XcruderModule.t','submit'), array(
			'onclick' => 'this.form.onsubmit()'
		));
	}

	public static function xpResetButton($form) {
		return XcruderHtml::resetButton( Yii::t('XcruderModule.t','reset'), array(
			'onclick'=>'$($(this).attr("form")).find("tr.selected").removeClass("selected")'
		));
	}
	
	public static function xpCancelButton($form) {
		return XcruderHtml::button( Yii::t('XcruderModule.t','cancel'), array(
				'onclick' => '$(this).parents(".ui-dialog-content").dialog("close")'
		));
	}

	public static function xpEndForm($controller) {
		$controller->endWidget();
	}
	

/**
 * 
 */	
	public static function getGridHeader($model, $relations, $column) {

		$colType = XcruderActiveRecord::getColumnType($model, $relations, $column);
		if (is_array($colType))
			$colType = $colType[0];

		return '<span class="arheader ' . $colType . ' __' . $column->name . '">' . $column->name . '</span>';
	}


/**
 * Returns the grid columns for the grid
 */
	public static function getGridColumns($model, $mode = '') {
		if (!@$model)
			return array();

		$gridColumns = array();
		$cols = $model->getTableSchema()->columns;
		$relations = $model->relations();
		
		//Adding a checkboxcolumn
		//if (!$mode || $mode=='rowpicker' || $mode == 'CManyManyRelation' || $mode == 'CHasManyRelation')
		$gridColumns[] =  array(
			'class' => 'CCheckBoxColumn',
			'selectableRows' => null//($mode == 'rowpicker' ? null : 2)
		);
		
		
		
		if ($mode == 'rowpicker') {
			//picker view: no more extra columns
		} else {

			$gridColumns[] =  array(

				'class' => 'CButtonColumn',
				'template' => '{view}{update}{delete}',

				'viewButtonUrl' => "'javascript:(function(){' . XcruderHtml::xpAjaxRenderRelateds(\$data). '})()'",
				'viewButtonOptions' => array(
					'class'=>'view'
				),

				'updateButtonUrl' => "'javascript:(function(){' . XcruderHtml::xpAjaxRenderUpdate(\$data). '})()'",
				'updateButtonOptions' => array(
					//'onmousedown' => 'xcruder.beforeUpdateClick(this)'
					//'onmousedown' => ""
					'class'=>'update'
				),
				
				//'deleteButtonUrl' => "'javascript:(function(){' . XcruderHtml::xpAjaxRenderDelete(\$data). '})()'",
				'deleteButtonUrl' => "'javascript:;'",
				'deleteButtonOptions' => array(
					'class'=>'delete',
					'onmouseup' => 'xcruder.onSingleDelete(this, "' . Yii::t('XcruderModule.t', $mode ? 'confirm-delete-single-record':'confirm-delete-single-relation') . '")'
				),

			);

		}

		//Adding all attribute columns
		foreach($cols as $key=>$col) {
		
			$ct = XcruderActiveRecord::getColumnType($model, $relations, $col);
			$isFk = is_array($ct);
			$fkClass = '';$fkPks = null;
			if ($isFk) {
				$fkClass = $ct[2][1];
				$fkPks = XcruderActiveRecord::getPkColumnNames(  $fkClass::model()->getTableSchema()->columns );
				//echo'<pre>';print_r($fkPks);echo'</pre>';
			}

			$gridColumns[] = array(
				'class'=>'CDataColumn',
				'type'=>'text',
				'name'=>$col->name,
				'header'=> self::getGridHeader($model, $relations, $col),
				//'value'=>'$data->attribute["' . $col->name . '"] . "-' . ''. '"',
				'htmlOptions' => $isFk ? array(
					'class'=>'fk',
					'onclick'=>'xcruder.changeModelClass("' . $fkClass . '", {"' . $fkPks[0]->name . '":this.innerHTML})',
					'style'=>'cursor:pointer',
					'title'=>Yii::t('XcruderModule.t', 'gotorecord')
				) : array()
			);

		}

		return $gridColumns;
	}

}
?>
